## Tool: `list_dependencies`

List dependency resources in the API hub.

The following sample demonstrate how to use `curl` to invoke the `list_dependencies` MCP tool.

| Curl Request |
|---|
| ```bash curl --location 'https://apihub.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "list_dependencies", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' ``` |

## Input Schema

The `ListDependencies` method's request.

### ListDependenciesRequest

| JSON representation |
|---|
| ``` { "parent": string, "filter": string, "pageSize": integer, "pageToken": string } ``` |

| Fields ||
|---|---|
| `parent` | `string` Required. The parent which owns this collection of dependency resources. Format: `projects/{project}/locations/{location}` |
| `filter` | `string` Optional. An expression that filters the list of Dependencies. A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string. Allowed comparison operator is `=`. Filters are not case sensitive. The following fields in the `Dependency` are eligible for filtering: - `consumer.operation_resource_name` - The operation resource name for the consumer entity involved in a dependency. Allowed comparison operators: `=`. - `consumer.external_api_resource_name` - The external api resource name for the consumer entity involved in a dependency. Allowed comparison operators: `=`. - `supplier.operation_resource_name` - The operation resource name for the supplier entity involved in a dependency. Allowed comparison operators: `=`. - `supplier.external_api_resource_name` - The external api resource name for the supplier entity involved in a dependency. Allowed comparison operators: `=`. Expressions are combined with either `AND` logic operator or `OR` logical operator but not both of them together i.e. only one of the `AND` or `OR` operator can be used throughout the filter string and both the operators cannot be used together. No other logical operators are supported. At most three filter fields are allowed in the filter string and if provided more than that then `INVALID_ARGUMENT` error is returned by the API. For example, `consumer.operation_resource_name = \"projects/p1/locations/global/apis/a1/versions/v1/operations/o1\" OR supplier.operation_resource_name = \"projects/p1/locations/global/apis/a1/versions/v1/operations/o1\"` - The dependencies with either consumer or supplier operation resource name as *projects/p1/locations/global/apis/a1/versions/v1/operations/o1*. |
| `pageSize` | `integer` Optional. The maximum number of dependency resources to return. The service may return fewer than this value. If unspecified, at most 50 dependencies will be returned. The maximum value is 1000; values above 1000 will be coerced to 1000. |
| `pageToken` | `string` Optional. A page token, received from a previous `ListDependencies` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `ListDependencies` must match the call that provided the page token. |

## Output Schema

The `ListDependencies` method's response.

### ListDependenciesResponse

| JSON representation |
|---|
| ``` { "dependencies": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.Dependency`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `dependencies[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.Dependency`)`` The dependency resources present in the API hub. |
| `nextPageToken` | `string` A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages. |

### Dependency

| JSON representation |
|---|
| ``` { "name": string, "consumer": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DependencyEntityReference`) }, "supplier": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DependencyEntityReference`) }, "state": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.State`), "description": string, "discoveryMode": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DiscoveryMode`), "errorDetail": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DependencyErrorDetail`) }, "createTime": string, "updateTime": string, "attributes": { string: { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, ... } } ``` |

| Fields ||
|---|---|
| `name` | `string` Identifier. The name of the dependency in the API Hub. Format: `projects/{project}/locations/{location}/dependencies/{dependency}` |
| `consumer` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DependencyEntityReference`)`` Required. Immutable. The entity acting as the consumer in the dependency. |
| `supplier` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DependencyEntityReference`)`` Required. Immutable. The entity acting as the supplier in the dependency. |
| `state` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.State`)`` Output only. State of the dependency. |
| `description` | `string` Optional. Human readable description corresponding of the dependency. |
| `discoveryMode` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DiscoveryMode`)`` Output only. Discovery mode of the dependency. |
| `errorDetail` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.DependencyErrorDetail`)`` Output only. Error details of a dependency if the system has detected it internally. |
| `createTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the dependency was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the dependency was last updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `attributes` | ``map (key: string, value: object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`))`` Optional. The list of user defined attributes associated with the dependency resource. The key is the attribute name. It will be of the format: `projects/{project}/locations/{location}/attributes/{attribute}`. The value is the attribute values associated with the resource. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |

### DependencyEntityReference

| JSON representation |
|---|
| ``` { "displayName": string, // Union field `identifier` can be only one of the following: "operationResourceName": string, "externalApiResourceName": string // End of list of possible types for union field `identifier`. } ``` |

| Fields ||
|---|---|
| `displayName` | `string` Output only. Display name of the entity. |
| Union field `identifier`. Required. Unique identifier for the participating entity. `identifier` can be only one of the following: ||
| `operationResourceName` | `string` The resource name of an operation in the API Hub. Format: `projects/{project}/locations/{location}/apis/{api}/versions/{version}/operations/{operation}` |
| `externalApiResourceName` | `string` The resource name of an external API in the API Hub. Format: `projects/{project}/locations/{location}/externalApis/{external_api}` |

### DependencyErrorDetail

| JSON representation |
|---|
| ``` { "error": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.Error`), "errorTime": string } ``` |

| Fields ||
|---|---|
| `error` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_dependency#Input.Schema.Error`)`` Optional. Error in the dependency. |
| `errorTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Optional. Timestamp at which the error was found. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |

### Timestamp

| JSON representation |
|---|
| ``` { "seconds": string, "nanos": integer } ``` |

| Fields ||
|---|---|
| `seconds` | `string (https://developers.google.com/discovery/v1/type-format format)` Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
| `nanos` | `integer` Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |

### AttributesEntry

| JSON representation |
|---|
| ``` { "key": string, "value": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) } } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` |

### AttributeValues

| JSON representation |
|---|
| ``` { "attribute": string, // Union field `Value` can be only one of the following: "enumValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`) }, "stringValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "jsonValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "uriValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) } // End of list of possible types for union field `Value`. } ``` |

| Fields ||
|---|---|
| `attribute` | `string` Output only. The name of the attribute. Format: projects/{project}/locations/{location}/attributes/{attribute} |
| Union field `Value`. The attribute values associated with the resource. `Value` can be only one of the following: ||
| `enumValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`)`` The attribute values associated with a resource in case attribute data type is enum. |
| `stringValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is string. |
| `jsonValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is JSON. |
| `uriValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is URL, URI or IP, like gs://bucket-name/object-name. |

### EnumAttributeValues

| JSON representation |
|---|
| ``` { "values": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`) } ] } ``` |

| Fields ||
|---|---|
| `values[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`)`` Required. The attribute values in case attribute data type is enum. |

### AllowedValue

| JSON representation |
|---|
| ``` { "id": string, "displayName": string, "description": string, "immutable": boolean } ``` |

| Fields ||
|---|---|
| `id` | `string` Required. The ID of the allowed value. \* If provided, the same will be used. The service will throw an error if the specified id is already used by another allowed value in the same attribute resource. \* If not provided, a system generated id derived from the display name will be used. In this case, the service will handle conflict resolution by adding a system generated suffix in case of duplicates. This value should be 4-63 characters, and valid characters are /\[a-z\]\[0-9\]-/. |
| `displayName` | `string` Required. The display name of the allowed value. |
| `description` | `string` Optional. The detailed description of the allowed value. |
| `immutable` | `boolean` Optional. When set to true, the allowed value cannot be updated or deleted by the user. It can only be true for System defined attributes. |

### StringAttributeValues

| JSON representation |
|---|
| ``` { "values": [ string ] } ``` |

| Fields ||
|---|---|
| `values[]` | `string` Required. The attribute values in case attribute data type is string or JSON. |

### State

Possible states for a dependency.

| Enums ||
|---|---|
| `STATE_UNSPECIFIED` | Default value. This value is unused. |
| `PROPOSED` | Dependency will be in a proposed state when it is newly identified by the API hub on its own. |
| `VALIDATED` | Dependency will be in a validated state when it is validated by the admin or manually created in the API hub. |

### DiscoveryMode

Possible modes of discovering the dependency.

| Enums ||
|---|---|
| `DISCOVERY_MODE_UNSPECIFIED` | Default value. This value is unused. |
| `MANUAL` | Manual mode of discovery when the dependency is defined by the user. |

### Error

Possible values representing an error in the dependency.

| Enums ||
|---|---|
| `ERROR_UNSPECIFIED` | Default value used for no error in the dependency. |
| `SUPPLIER_NOT_FOUND` | Supplier entity has been deleted. |
| `SUPPLIER_RECREATED` | Supplier entity has been recreated. |

### Tool Annotations

Destructive Hint: ❌ \| Idempotent Hint: ✅ \| Read Only Hint: ✅ \| Open World Hint: ❌